#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Apr  9 11:58:41 2018
d
@author: alirezagoudarzi
"""
import torch
from torch.autograd import Variable
import torch.nn as nn
import torch.nn.functional as F

class LeNet(nn.Module):
    def __init__(self,BN=True):
        super(LeNet, self).__init__()
        self.BN= BN;
        self.conv1 = nn.Conv2d(1, 20, 3,groups=1) # group convolution
        if self.BN:
            self.bn1 = nn.BatchNorm2d(20); # batchnormalization layer to keep the data centered
        self.pool1 = nn.MaxPool2d(2);  # pooling layer
        self.conv2 = nn.Conv2d(20, 10, 3,groups=1) # group convolution     
        if self.BN:
            self.bn2 = nn.BatchNorm2d(10); # batchnormalization layer to keep the data centered      
        self.pool2 = nn.MaxPool2d(2)
        self.actfunc = F.relu; # define a global activation function.
        
        self.lin = nn.Linear(250,10); # define our dense layer


    def forward(self, x):
        out = self.conv1(x);
        if self.BN:
            out = self.bn1(out);
        out = self.actfunc(out);
        out = self.pool1(out);

        out = self.conv2(out);
        if self.BN:
            out = self.bn2(out);
        out = self.actfunc(out);
        out = self.pool2(out);
        out = self.lin(out.view(x.size(0),-1))
        out = F.log_softmax(out,dim=1);
        return out
        
